package com.yame.control;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;

import static org.junit.Assert.*;

import java.util.HashMap;

import com.fasterxml.jackson.core.JsonEncoding;
import com.jayway.jsonpath.DocumentContext;
import com.jayway.jsonpath.JsonPath;
import com.jayway.jsonpath.ReadContext;
import com.yame.uml.Application;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import lombok.extern.slf4j.Slf4j;

/**
 * TestAPI
 */


@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(classes = Application.class, webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@Slf4j
public class TestAPI {

    @LocalServerPort
    String port;

    @Autowired
    TestRestTemplate rest;

    String domain;

    @Before
    public void init() {
        domain = "http://localhost:" + port;
    }
    
    @Test
    public void uml2SVG() {
 
        MultiValueMap<String, String> map = new LinkedMultiValueMap<>();
        map.add("data", "123");
        String resp = rest.postForObject(domain + "/api/v1/uml2svg", map, String.class);
        ReadContext cxt = JsonPath.parse(resp);
        assertEquals(cxt.read("$.type").toString(), "{desc=Error Source2SVG, code=-102, success=false}");

        log.info(resp.toString());
    }
}